;========================= DOSEXT PRINT functions. ===========================

decistr  db "0000000000$"
hexastr  db "00000000h$"

;
; Print a decimal number
; In:
;   EAX - value
; Out:
;   registers preserved.
;
Printdeci proc near
          Push esi ebx edx eax
          Mov esi,offset decistr+9
          Mov ebx,10
 @@Nxtchif:
          Xor edx,edx
          Div ebx
          Add dl,30h
          Mov [esi],dl
          Dec esi
          Or eax,eax
          Jnz short @@Nxtchif
          Mov ah,09h
          Lea edx,[esi+1]
          Int 21h
          Pop eax edx ebx esi
          Ret
Printdeci endp

;
; Print a hexadecimal number
; In:
;   EAX - value
; Out:
;   registers preserved.
;
Printhexa proc near
          Push edi ebx edx eax
          Mov edi,offset hexastr-1
          Mov edx,8
 @@Nxtchif:
          Movzx ebx,al
          And bl,0Fh
          Mov bl,[hexatbl+ebx]
          Mov [edi+edx],bl
          Shr eax,4
          Dec edx
          Jnz short @@Nxtchif
          Lea edx,[edi+1]
          Mov ah,09h
          Int 21h
          Pop eax edx ebx edi
          Ret
Printhexa endp

;
; Print a dos string lower than 1Mo.
; In:
;   EDX - offset of string
; Out:
;   Destroys regs._dx regs._ax regs._ss regs._sp
;
Printstr  proc near
          Push eax ebx ecx edx edi
          Add edx,codeaddx
          Mov edi,offset regs
          Mov al,dl
          And ax,000Fh
          Shr edx,4
          Mov [edi]._dx,ax
          Mov [edi]._ds,dx
          Mov [edi]._ah,09h
          Mov bl,21h
          Call RealInt
          Pop edi edx ecx ebx eax
          Ret
Printstr  endp
